import { Event, ErrorEvent, Events } from 'hint/dist/src/lib/types/events';
import { IJSONLocationFunction, ISchemaValidationError } from 'hint/dist/src/lib/types';
import * as TypeScript from 'typescript';
export declare type TypeScriptConfig = {
    compilerOptions: TypeScript.CompilerOptions;
    compileOnSave: boolean;
    extends: string;
    files: string[];
    include: string[];
    exclude: string[];
    typeAcquisition: TypeScript.TypeAcquisition;
};
export declare type TypeScriptConfigInvalidJSON = ErrorEvent;
export declare type TypeScriptConfigInvalidSchema = ErrorEvent & {
    errors: ISchemaValidationError[];
    prettifiedErrors: string[];
};
export declare type TypeScriptConfigParseStart = Event;
export declare type TypeScriptConfigParse = Event & {
    config: TypeScriptConfig;
    getLocation: IJSONLocationFunction;
    originalConfig: TypeScriptConfig;
};
export declare type TypeScriptConfigEvents = Events & {
    'parse::end::typescript-config': TypeScriptConfigParse;
    'parse::error::typescript-config::circular': ErrorEvent;
    'parse::error::typescript-config::extends': ErrorEvent;
    'parse::error::typescript-config::json': TypeScriptConfigInvalidJSON;
    'parse::error::typescript-config::schema': TypeScriptConfigInvalidSchema;
    'parse::start::typescript-config': TypeScriptConfigParseStart;
};
